#include <cstdlib>
#include <string>
#include <iostream>
extern "C"
{
#include "iio.h"
}



int main(int argc, char *argv[])
{
    // check command line arguments
    if (argc < 3 || argc > 4 ) {
        std::cerr<<"usage:\n\t"<<argv[0]<<"in out"<<std::endl;
        //                          0          1      2      3   4  5  6  7   8    9
        return EXIT_FAILURE;
    }
    std::cout<<"running image conversion"<<std::endl;
    std::string inName= (argc>1)? argv[1] : "-";
    std::string outName= (argc>2)? argv[2] : "-";
    // read input image "im"
    int w,h,pd;
    float *buf = static_cast<float*>(iio_read_image_float_split(inName.c_str(), &w, &h, &pd));
    // save output image
    iio_save_image_float_split(const_cast<char*>(outName.c_str()), buf, w, h, pd);
    free(buf);
    return 0;
}
