import numpy as np 
## Tri Diagonal Matrix Algorithm(a.k.a Thomas algorithm) solver

def TDMAsolver(a,b,c,d):
   '''
   TDMA solver, a b c d can be NumPy array type or Python list type.
   refer to http://en.wikipedia.org/wiki/Tridiagonal_matrix_algorithm (in fact this article is really crappy)
   '''
   n=len(d)
   aa=np.concatenate(([0.],a.astype(float)))# to insure aa[i] to be on row i and not on row i+1
   bb,cc,dd=[np.array(v).astype(float) for v in b,c,d]# convert to float to avoid integer divisions
   # forward pass: elimination in order to get a=0 
   for i in xrange(1,n):#(int i = 1; i < n; i++)
      m = a[i-1]/bb[i-1];
      bb[i] = bb[i] - m*cc[i - 1];#equivalent to setting a[i] to 0
      dd[i] = dd[i] - m*dd[i-1];    #and has this effect on dd[i], and none on c[i]
   # backward pass: substitution
   x=[0 for i in xrange(n)]
   x[n-1] = dd[n-1]/bb[n-1]
   for i in xrange(n-2,-1,-1):#(int i = n - 2; i >= 0; i--)
      x[i] = (dd[i] - cc[i] * x[i+1]) / bb[i];
   return x


def test():
    a=np.arange(1,8)  # this is the lower diagonal
    b=np.arange(1,9)*2# this is the diagonal
    c=np.arange(3,10) # and the upper diagonal
    d=np.array([np.arange(4,12), np.arange(7,15)]).T
    A=np.diag(a,-1)+np.diag(b)+np.diag(c,1)
    x=np.linalg.solve(A,d)
    print x
    print np.dot(A,x)
    xc=TDMAsolver(a,b,c,d)
    print 'xc   ',xc
    print 'A*xc ',np.dot(A,xc)
    print 'd    ',d

if __name__ == '__main__':
   test()
